/*******************************************************************************
  *
  *  program     : jdRectangle.java
  *  author      : Helge Janicke
  *  version     : 2000-10-19(001)
  *  (c)         : Helge Janicke, Karsten Wolke, Niels-Peter de Witt
  *  email       : heljanic@agent.fho-emden.de
  *  description : Diese Klasse reprsentiert ein Rechteck.
  ******************************************************************************
  * modifications:
  * date: ******* who: ****** description: *************************************
  * ----------------------------------------------------------------------------
  * 2000-10-19    heljanic
  * ----------------------------------------------------------------------------
  ******************************************************************************
  * comments:
  *
  ******************************************************************************
  * license:
  *
*******************************************************************************/
package jdraw;

import java.awt.geom.Rectangle2D;
import java.awt.event.MouseEvent;
import java.awt.geom.AffineTransform;
import java.awt.geom.Point2D;
import java.awt.Shape;

/** Diese Klasse reprsent ein Rechteck, eine Instanz kann von jdRectangleGenerator generiert werden. */
public class jdRectangle extends SimpleGraphObject implements Transformable {
  private Rectangle2D rect = null;
  private Rectangle2D dragRect = null;

  public jdRectangle() {
    rect = new Rectangle2D.Double(0,0,0,0);

    this.setShape(rect);
  }

  public jdRectangle(double x, double y, double w, double h) {
    this();
    rect.setRect(x, y, w, h);
  }

  public jdRectangle(Rectangle2D rect) {
    this();
    this.rect.setRect(rect);
  }

  public AbstractAccessPoint[] getAccessPoints(int usage) {
  return null;
    //TODO: Implement this jdraw.Transformable method
  }

  public AbstractAccessPoint[] getAccessPoints() {
    return null;
    //TODO: Implement this jdraw.Transformable method
  }

  public void freeAccessPoints() {
    //TODO: Implement this jdraw.Transformable method
  }

  public void handleAccessPointPressed(MouseEvent e, AbstractAccessPoint ap) {
    //TODO: Implement this jdraw.Transformable method
  }

  public void handleAccessPointDragged(MouseEvent e, AbstractAccessPoint ap) {
    //TODO: Implement this jdraw.Transformable method
  }

  public void handleAccessPointReleased(MouseEvent e, AbstractAccessPoint ap) {
    //TODO: Implement this jdraw.Transformable method
  }

  public void handleGroupTransformation(AffineTransform at, Rectangle2D groupBounds) {
    //TODO: Implement this jdraw.Transformable method
  }

  public void handleDrag(MouseEvent e, Point2D startPoint) {
  double dx = e.getX() - startPoint.getX();
  double dy = e.getY() - startPoint.getY();
    dragRect = (Rectangle2D) rect.clone();
    dragRect.setRect(rect.getX()+dx,rect.getY()+dy,rect.getWidth(),rect.getHeight());
    //TODO: Implement this jdraw.Transformable method
  }

  public void handleDrop(MouseEvent e, Point2D startPoint) {
    rect.setRect(dragRect);

    dragRect = null;
    //TODO: Implement this jdraw.Transformable method
  }

  public boolean isGroupTransformationSupported() {
    return true;
    //TODO: Implement this jdraw.Transformable method
  }

  public Shape supportDragShape() {
    //TODO: Implement this jdraw.Transformable method
    return dragRect;
  }

  public Shape supportSelectedShape() {
    //TODO: Implement this jdraw.Transformable method
    return null;
  }

  public boolean isFilled() { return true; }

}