/*******************************************************************************
  *
  *  program     : Infoable.java
  *  author      : Helge Janicke
  *  version     : 2000-10-19(001)
  *  (c)         : Helge Janicke, Karsten Wolke, Niels-Peter de Witt
  *  email       : heljanic@agent.fho-emden.de
  *  description : some description here
  *
  ******************************************************************************
  * modifications:
  * date: ******* who: ****** description: *************************************
  * ----------------------------------------------------------------------------
  * 2000-10-19    heljanic
  * ----------------------------------------------------------------------------
  ******************************************************************************
  * comments:
  *
  ******************************************************************************
  * license:
  *
*******************************************************************************/
package jdraw;
import javax.swing.JPanel;

/** Eine Zeichenobjekt, die das Infoable Interface implementiert mu ein Panel
  * zur Verfgung stellen, da Informationen zu dem Objekt enthlt wie zum
  * Beispiel Anfangs und EndPunkt einer Linie.
  */
public interface Infoable {

  /** Liefert das JPanel, da die Informationen ber das Zeichenonjekt enthlt.
    * @return Das InfoPanel.
    */
  public JPanel getInfoPanel();

  /** Erzeugt kein neues Panel, sondern aktualiesiert nur die Informationen in
    * dem aktuellen InfoPanel.
    * @param o Das ZeichenObjekt, dessen Eigenschaften angezeigt werden sollen.
    */
  public void updateInfoPanel(AbstractGraphObject o);
}